

void checkSerial(){

    serialString = "";
    int loops = 0;

    while ((port.available() > 0))  {    

        serialString = trim(port.readStringUntil(13)); 
        if(loops++ > 1){
            println("stuck!");  
            port.clear(); 
        }
    }

   // if (serialString=="") {println("--null");}

    if ((serialString == null) | (serialString.equals(""))) {
        port.clear();
        serialString = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0";   
        println("reset...");
    }

    convertSerialToValues();    
}


void debugSerial(){

    if (sensorValues.length >= (totalSensors)){
        
        turn3DOff();
        
        
        for (int i = 0; i < totalSensors; i++){
            
            fill(50,100,100);
            
            textFont(font, 18); 
            text(sensorValues[i], 50 + i * 50, 50); 
            
            textFont(font, 9); 
            text(sensorName[i], 50 + i * 50, 35);
            textFont(japaneseFont, 12);
            text(japaneseWords[0], 50 + i * 50, 14);
            
            fill(50,100,100);
            rectMode(CORNERS);
            rect(47+i*50,50,49+i*50,50 - (40 * (sensorValues[i] - sensorMin[i]) / (1024/sensorScale[i])));
        }
        
        
       
        for (int i = 0; i < totalActuators; i++){
            
             fill(0,100,100);
            
            textFont(font, 18); 
            text(actuatorValues[i], 50 + i * 100, 100); 
            textFont(font, 9); 
            text(actuatorName[i], 50 + i * 100, 85);
            
            fill(0,100,100);
            rect(47+i*100,100,49+i*100,100 - (40 * actuatorValues[i] / (1024/actuatorScale[i])));
        }
        
        // display boredom & madness
        
            fill(75,100,100);
            textFont(font, 18); 
            text(boredom, 50, 150); 
            textFont(font, 9); 
            text("boredom", 50, 135);          
            fill(75,100,100);
            rect(47,150,49,150 - (40 * boredom / 1024.0));

        
            fill(75,100,100);
            textFont(font, 18); 
            text(madness, 100, 150); 
            textFont(font, 9); 
            text("madness", 100, 135);          
            fill(75,100,100);
            rect(97,150,99,150 - (40 * madness / 1024.0));

        
            fill(75,100,100);
            textFont(font, 18); 
            text(moodCurrent, 150, 150); 
            textFont(font, 9); 
            text("moodCurrent", 150, 135);          
            fill(75,100,100);
            rect(147,150,149,150 - (40 * moodCurrent / 1024.0));

        
        
        
        
        turn3DOn();
    }



    





}
