// sensors
int totalSensors = 11;
int moodSen = 0;
int phoneSen = 4;
int cat1Sen = 1;
int lili1Sen = 6;
int lili2Sen = 7;
//int cat2Sen = 8;
int mist1Sen = 5;
int mist2Sen = 3;
int monkeySen = 2;
//int monkey2Sen = 9;
int nc = 8;
int exmlHDR = 9;
//int exmlAET = 16;
int mp3Sen = 10;
//int fixedValue = 15;
int[] senX;
int[] senY;
int[] senZ;


// Actuators
int totalActuators = 7; // was 8
int lili1Act = 1;
int lili2Act = 0;
int penguin1Act = 2;
int penguin2Act = 3;
int sqrlAct = 4;
int cat1Act = 5;
//int soundCellVolumeAct = 6;
int mp3Act = 6;

int[] actX;
int[] actY;
int[] actZ;


// connections


    int[] cat1Pos = {
        60, -60, 100             };
    int[] cat2Pos = {
        -60, -220, 120             };
    int[] lili2Pos = {
        -210, -120, 0          };
    int[] lili1Pos = {
        90, 20, 0            };
    int[] penguin1Pos = { 
        -90, 120, 320              };
    int[] penguin2Pos = { 
        -90, -120, 320                 };
    int[] mist1Pos = { 
        130, 150, 130                };
    int[] mist2Pos = { 
        60, 220, 100              };
    int[] mp3Pos = { 
        -215, -130, 170      };
    int[] sqrlPos = {
        -10, 220, 150                 };
    int[] monkeyPos = {
        -205, -35, 100                };    

    int[] moodPos = {
        -160, -230, 120                 };    
    int[] phonePos = {
        85, -30, 240      };
        



boolean testingMood;

void setInitialConnections(){
    sensorFor[lili1Act] = nc;
    sensorFor[lili2Act] = nc;
    sensorFor[penguin1Act] = nc;   
    sensorFor[penguin2Act] = nc;   
    sensorFor[cat1Act] = nc;   
    sensorFor[sqrlAct] = nc;
   // sensorFor[soundCellVolumeAct] = nc;
    sensorFor[mp3Act] = nc;
    
    testingMood = false;
    
}

void setAllSensorScales(){
    setSensorScales(cat1Sen, "cat1Sen", 10, 155, -60, -220, 120);
//    setSensorScales(cat2Sen, "cat2Sen", 0, 90);
    setSensorScales(lili1Sen, "lili1Sen", 0, 90, 90, 20, 0);
    setSensorScales(lili2Sen, "lili2Sen", 0,90, -210, -120, 0);
    setSensorScales(mist1Sen, "mist1Sen", 20, 100, 130, 150, 130);
    setSensorScales(mist2Sen, "mist2Sen", 16, 60, 60, 220, 100 );
    setSensorScales(monkeySen, "monkeySen", 5, 291, -205, -35, 100);
//    setSensorScales(monkey2Sen, "monkey2Sen", 20, 1023);
    setSensorScales(moodSen, "moodSen", 212, 324, -160, -230, 120  );
    setSensorScales(phoneSen, "phoneSen", 0, 39, 85, -30, 240 );
    setSensorScales(nc, "nc", 0, 0, 0, 0, 0);
    setSensorScales(exmlHDR, "exmlHDR", 1300, 1400, 0, 0, 0);
//    setSensorScales(exmlAET, "exmlAET", 1300, 1400);
    setSensorScales(mp3Sen, "mp3Sen", 30, 150, -215, -130, 170 );
}

void setAllActuatorScales(){
    setActuatorScales(lili1Act, "lili1Act", 256, 90, 20, 0 ); // was 256
    setActuatorScales(lili2Act, "lili2Act", 256, -210, -120, 0); // was 256  
    setActuatorScales(penguin1Act, "penguin1Act", 100, -90, 120, 320 );
    setActuatorScales(penguin2Act, "penguin2Act", 100, -90, -120, 320 );
    setActuatorScales(sqrlAct, "sqrlAct", 200, -10, 220, 150 );
    setActuatorScales(cat1Act, "cat1Act", 256, -60, -220, 120);
   // setActuatorScales(soundCellVolumeAct, "soundCellVolumeAct", 700, 0,0,0);
    setActuatorScales(mp3Act, "mp3Act", 80000, -215, -130, 170); 

    for (int i = 0; i < totalActuators; i++) { 
        senPopularFor.add(new Integer[totalActuators]);   
        sensorPopularity = new int[totalSensors];
        for (int j = 0; j < totalSensors; j++){
            sensorPopularity[j] = 0;
        }  
        sensorPopularity[nc] = 1;
        senPopularFor.set(i, sensorPopularity);
    }
}


int getDeviceID(String selectedDevice){

    int returnValue = 999;

    for (int i = 0; i < totalSensors; i++){
        if (selectedDevice.equals(sensorName[i])) {
            returnValue = i; 
        } 
    }
    for (int i = 0; i < totalActuators; i++){
        if (selectedDevice.equals(actuatorName[i])) {
            returnValue = i; 
        }
    }

    return returnValue;

}


void fingerConnects(String aName, String sName){

    int sAct = getDeviceID(aName);
    int sSen =  getDeviceID(sName);
    if ((sAct < 999) & (sSen < 999)) {
        sensorFor[sAct] = sSen;
        println("sensorFor[" +aName + "] = " + sName);

        sensorPopularity = new int[totalSensors];
        sensorPopularity = (int []) senPopularFor.get(sAct); 
        sensorPopularity[sSen]++;
        print(sensorPopularity);
        senPopularFor.set(sAct, sensorPopularity);
        println("\nmost popular sensor for " + aName + " is " + sensorName[returnMostPopularFor(sAct)]);
    }
    else {
        println("that actuator or sensor doesn't exist!");
    }
}





int returnMostPopularFor(int thisActuator){

    int mostPopular = nc;
    int biggestPopularity = 0;
    sensorPopularity = new int[totalSensors];
    sensorPopularity = (int []) senPopularFor.get(thisActuator); 
    for (int i = 0; i < totalSensors; i++){     
        if (sensorPopularity[i] > biggestPopularity) { 
            mostPopular = i; 
            biggestPopularity = sensorPopularity[i];
        }
    }
    return mostPopular;
}

int scaleActuator(int out, int value){
    return int(value / actuatorScale[out]);
}

int scaleSensor(int in, int value){
    return constrain(int(sensorScale[in] * (value - sensorMin[in])),0,1023);
}

void setSensorScales(int deviceId, String deviceName, int minimum, int maximum, int x, int y, int z){
    sensorMin[deviceId] = minimum;
    sensorMax[deviceId] = maximum;
    sensorScale[deviceId] = 1023.0 / (maximum - minimum);
    println(deviceId);
    sensorName[deviceId] = deviceName;
    senX[deviceId] = x;
    senY[deviceId] = y;
    senZ[deviceId] = z;
}


void setActuatorScales(int deviceId, String deviceName, int maximum, int x, int y, int z){
    actuatorScale[deviceId] = 1024.0 / maximum;
    actuatorName[deviceId] = deviceName;
    actX[deviceId] = x;
    actY[deviceId] = y;
    actZ[deviceId] = z;
}

void mapValues(){
    //moodCurrent = scaleSensor(moodSen, readSensor(moodSen));
    for (int i = 0; i < totalActuators; i++){
        int currentSensor = sensorFor[i];
        actuatorValues[i] = scaleActuator(i, scaleSensor(currentSensor,readSensor(currentSensor)));//int((mood/1024.0) * scaleActuator(i, scaleSensor(currentSensor,readSensor(currentSensor)))); 
    }
    recObj.setVolume(1.0);//actuatorValues[soundCellVolumeAct] / 100.0);
    recObj.setRate(actuatorValues[mp3Act] + 20000);
    updateExmlValues();
}


void convertSerialToValues(){

    sensorValueString = serialString.split(" ");
    
     sensorValueString = subset(sensorValueString,  0, sensorValueString.length -3);
     //print(sensorValueString);
     //println("");
   // print( sensorValueString);
    
    int sensorValueStringLength = sensorValueString.length;


    sensorValues = new int[sensorValueStringLength];

    for (int j = 0; j < sensorValueStringLength; j++){       
        sensorValues[j] = int(sensorValueString[j]); 
    }

    
    
    sensorValues[lili1Sen] = actuatorValues[lili1Act];
    sensorValues[lili2Sen] = actuatorValues[lili2Act];
    if (testingMood) {sensorValues[moodSen] = testMood;}
    sensorValues[nc] = 0;
    sensorValues[exmlHDR] = int(exmlValueHDR);
    sensorValues[mp3Sen] = int(LiveInput.getLevel() * 1024);
    
    //   if (sensorValues.length>0){

 //       sensorValues = append(sensorValues,int(exmlValueHDR));
//        sensorValues = append(sensorValues,int(exmlValueAET));
 //       sensorValues = append(sensorValues,int(LiveInput.getLevel() * 1024));
 //   }  
}

void resetConnections(){
    println("panic... resetting connections");
    for (int i = 0; i < totalActuators; i++){
        sensorFor[i] = nc;
    }   
    stopBeingBored();
}


void connectMostPopular(){
    println("making most popular connections...");
    for (int i = 0; i < totalActuators; i++){
        sensorFor[i] = returnMostPopularFor(i);
    }   
    stopBeingBored();
}


