int curviness = 50;

int x1;
int y1;
int z1;

int x2;
int y2;
int z2;

int x4;
int y4;
int z4;

int x3;
int y3;
int z3;

int thisActuatorsSensor;

int connectionStyle = 0; // 0: line -- 1: curve -- 2: triangle

int tSize = 10;

void drawConnections(){


    stroke(0, 0, 40, 40);  

    if (frameCount % 15 == 0) 
    {
        strokeWeight(1);
    }

    else 

    {  
        strokeWeight(2);

    }



    for (int i = 0 ; i < totalActuators; i++){

        thisActuatorsSensor = sensorFor[i];

        if (thisActuatorsSensor != nc){

            x1 = senX[thisActuatorsSensor];
            y1 = senY[thisActuatorsSensor];
            z1 = senZ[thisActuatorsSensor];

            x4 = actX[i];
            y4 = actY[i];
            z4 = actZ[i];


            if (connectionStyle == 1) {
                x2 = senX[thisActuatorsSensor] + curviness;
                y2 = senY[thisActuatorsSensor] + curviness;
                z2 = senZ[thisActuatorsSensor] + curviness;

                x3 = actX[i] + curviness;
                y3 = actY[i] + curviness;
                z3 = actZ[i] + curviness;

                bezier(x1, y1, z1, x2, y2, z2, x3, y3, z3, x4, y4, z4);

            } 

            else 

                if (connectionStyle == 0) {

                line( x1,y1,z1,x4,y4,z4);   

            }

            if (connectionStyle == 2) {
                fill(0,20,40,40);
                beginShape(TRIANGLES);
                vertex(x1, y1, z1);
                vertex(x4, y4, z4);
                vertex(x4+tSize,y4+tSize,z4);
                endShape(); 

            }

        }

    }

    strokeWeight(1);
}
