
void drawLilies(){
    noStroke();
    translate(-50, 0, 0);
    rotateZ(radians(-10));
    pushMatrix();
    translate(130, -210, 0);
    for (int i=0; i<4; i++){ 
        translate(8, 0, 0);
        pushMatrix();
        for (int j=0; j<60; j++){
            translate(0, 8, 0);
            // dispatch colors
            if (selectedDevice == "lili1" && fingerOverSensor){
                fill(0, 0, 100, 40);

            }
            else if (fingerOverSensor && lili1[1] == 0) {
                fill(lili1[2], 0, 10, 10);
            } 
            else if (fingerOverActuator && lili1[0] == 0) {
                fill(lili1[2], 0, 10, 10);
            }  
            else {
                fill(lili1[2], 100, 100, (frameCount * 1 + i * 5 + j * 5)%100);
            }


            box((frameCount * 0.61 + i * 5 + j * 5)%16);
        }
        popMatrix();
    }


    rotateZ(radians(10));
    translate(-310, 10, 0);
    for (int i=0; i<4; i++){ 
        translate(8, 0, 0);
        pushMatrix();
        for (int j=0; j<30; j++){
            translate(0, 8, 0);
            // dispatch colors

            if (selectedDevice == "lili2" && fingerOverSensor){
                fill(0, 0, 100, 40);

            }

            else if (fingerOverSensor && lili2[1] == 0) {
                fill(lili2[2], 0, 10, 10);
            } 
            else if (fingerOverActuator && lili2[0] == 0) {
                fill(lili2[2], 0, 10, 10);
            }  
            else {
                fill(lili2[2], 100, 100, (frameCount * 1 + i * 5 + j * 5)%100);
            }
            box((frameCount * 0.61 + i * 5 + j * 5)%16);
        }
        popMatrix();
    }



    popMatrix();
}
