// stuff for Environment XML

DataIn dIn;
DataOut dOut;

void setupExml(){

    dIn = new DataIn(this, "http://www.haque.co.uk/environmentxml/live/xml/79.xml", 5000);


    dOut = new DataOut(this, 5230);

    for (int i = 0; i < totalSensors+2; i++){

        if (i == nc) { 
            dOut.setTag(i, "noConnection"); 
        } 
        else
            if (i == 11) { 
                dOut.setTag(i, "madness"); 
            }
            else 
                if (i == 12) { 
                dOut.setTag(i, "boredom"); 
            }
            else {
                dOut.setTag(i, sensorName[i].substring(0, sensorName[i].length()-3)+"Sensor");
            }

    }

    exmlValueHDR = 0;

    for (int i = 0; i < totalActuators; i++){

        dOut.setTag(i + totalSensors + 2, actuatorName[i].substring(0, actuatorName[i].length()-3)+"Actuator,connection");

    }


    // exmlValueAET = 0;   

}

void onReturnEnvironmentXML(DataIn d){
    exmlValueHDR = d.getIdValue(1);
    //exmlValueAET = d.getIdValue(1);
    //println("exml sound: " + exmlValueHDR);
}



void onRequestEnvironmentXML(DataOut d){
    println("Client request received.");
}



void updateExmlValues(){

    if (sensorValues.length >= totalSensors){

        for (int i=0; i<totalSensors; i++){


            dOut.update(i, float(sensorValues[i]));

        }

        dOut.update(11, float(madness)); 
        dOut.update(12, float(boredom));         
    }

    for (int i = 0; i < totalActuators; i++){

        dOut.update(i+totalSensors+2, sensorFor[i]);

    }

}
