void startFullscreen() {
    frame.dispose();  
    frame.setUndecorated(true);  

    GraphicsDevice myGraphicsDevice = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice  ();  
    myGraphicsDevice.setFullScreenWindow(frame);  
    if (myGraphicsDevice.isDisplayChangeSupported()) {  
        DisplayMode myDisplayMode = new DisplayMode(  
        width,  
        height,  
        32,  
        DisplayMode.REFRESH_RATE_UNKNOWN);  
        myGraphicsDevice.setDisplayMode(myDisplayMode);  
    }  
}  

void stopFullscreen() {  
    GraphicsDevice myGraphicsDevice = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice  ();  
    myGraphicsDevice.setFullScreenWindow(null);  
} 
