import processing.net.*;
import environmentxml.*;
import processing.serial.*;


boolean debugging = false;

Serial port;                        
PFont font;
PFont japaneseFont;
String serialString = "";
int high;
String[] sensorValueString;

int[] sensorValues;

int[] sensorFor;

String[] sensorName;
String[] actuatorName;

int[] actuatorValues;
float[] actuatorScale;

int[] sensorMin;
int[] sensorMax;
float[] sensorScale;

ArrayList senPopularFor = new ArrayList() ; 
int[] sensorPopularity;

float exmlValueHDR;
float exmlValueAET;
int fixed;

boolean runTime;


int testMood = 400;


String[] japaneseWords;


void setup() {

    runTime = true;
    //frameRate(60);

    size(1280, 800, OPENGL);
    println(Serial.list());
    if (finalMachine) {
        println("Their mac");
        startFullscreen();
        port = new Serial(this, Serial.list()[0], 57600);
    } else {
        println("My mac");
     port = new Serial(this, Serial.list()[0], 57600);  
    }
    
    // 
    colorMode(HSB, 100);  
    frameRate(60);
    UISetup();






    actuatorValues = new int[totalActuators];
    


    sensorFor = new int[20];
    actuatorScale = new float[20];

    sensorMin = new int[20];
    sensorMax = new int[20];
    sensorScale = new float[20];
    
    senX = new int[totalSensors];
    senY = new int[totalSensors];
    senZ = new int[totalSensors];
      
    actX = new int[totalActuators];
    actY = new int[totalActuators];
    actZ = new int[totalActuators];
      
    sensorValues = new int[totalSensors];
    sensorName = new String[totalSensors];
    actuatorName = new String[totalActuators];

    setAllActuatorScales();
    setAllSensorScales();
    setInitialConnections();
 




    // size(800,100);
    font = loadFont("FakeReceipt-16.vlw"); 
    
    //port = new Serial(this, Serial.list()[0], 57600);
    //hint(ENABLE_NATIVE_FONTS);


    japaneseWords = new String[0];
            japaneseWords = append(japaneseWords, "????");

    char[] tempChar = new char[0];

    for (int i = 0; i < japaneseWords.length; i++){
        for (int j = 0; j < japaneseWords[i].length(); j++){
            tempChar = append(tempChar, japaneseWords[i].charAt(j));
        }
    }

    japaneseFont = createFont("japanese.ttf",12,true,tempChar); 

    fill(255);

    setupExml();
 
    setupSonia();



}







public void stop(){
    Sonia.stop();
    super.stop();
    try {
        dataFile.close();
        println("closing last log");
    }  
    catch(Exception e)  
    {  
        println("Error: problem with file: " + e); 
    } 

}


